// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QExport3PDF.pas' rev: 6.00

#ifndef QExport3PDFHPP
#define QExport3PDFHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Graphics.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Variants.hpp>	// Pascal unit
#include <QExport3.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qexport3pdf
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TPDFFontName { poHelvetica, poHelveticaBold, poHelveticaOblique, poHelveticaBoldOblique, poCourier, poCourierBold, poCourierOblique, poCourierBoldOblique, poTimesRoman, poTimesBold, poTimesItalic, poTimesBoldItalic, poSymbol, poZapfDingbats };
#pragma option pop

#pragma option push -b-
enum TPDFFontEncoding { poStandardEncoding, poWinAnsiEncoding, poMacRomanEncoding, poPDFDocEncoding };
#pragma option pop

class DELPHICLASS TPDFFont;
class PASCALIMPLEMENTATION TPDFFont : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	AnsiString FFontName;
	TPDFFontName FBaseFont;
	int FFontSize;
	TPDFFontEncoding FFontEncoding;
	Graphics::TColor FFontColor;
	
public:
	__fastcall TPDFFont(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property AnsiString FontName = {read=FFontName, write=FFontName};
	
__published:
	__property TPDFFontName BaseFont = {read=FBaseFont, write=FBaseFont, default=0};
	__property TPDFFontEncoding FontEncoding = {read=FFontEncoding, write=FFontEncoding, default=1};
	__property int FontSize = {read=FFontSize, write=FFontSize, default=10};
	__property Graphics::TColor FontColor = {read=FFontColor, write=FFontColor, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TPDFFont(void) { }
	#pragma option pop
	
};


class DELPHICLASS TPDFDocument;
class DELPHICLASS TPDFBox;
class PASCALIMPLEMENTATION TPDFBox : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FLeft;
	int FBottom;
	int FRight;
	int FTop;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property int Left = {read=FLeft, write=FLeft, nodefault};
	__property int Bottom = {read=FBottom, write=FBottom, nodefault};
	__property int Right = {read=FRight, write=FRight, nodefault};
	__property int Top = {read=FTop, write=FTop, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TPDFBox(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TPDFBox(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TPDFDocument : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TStream* FPDFFile;
	Classes::TStringList* FPageContents;
	int FStreamBegin;
	Classes::TStringList* FObjOffsets;
	Classes::TStringList* FFonts;
	int FObjNumber;
	TPDFFont* FFont;
	double FLineWidth;
	double FLineSpacing;
	Graphics::TColor FLineColor;
	Graphics::TColor FFillColor;
	TPDFBox* FMediaBox;
	TPDFBox* FTrimBox;
	int __fastcall AddObj(void);
	void __fastcall WriteStr2PDF(AnsiString Source);
	void __fastcall WriteBOF(void);
	int __fastcall WriteCatalog(int PagesNum, int OutLinesNum);
	int __fastcall WriteOutLines(void);
	int __fastcall WriteResources(void);
	int __fastcall WritePages(int FontsObj);
	int __fastcall WriteXref(void);
	void __fastcall WriteTrailer(int CatalogNum, int XrefOffset);
	void __fastcall WriteEof(void);
	void __fastcall SetFont(TPDFFont* Value);
	TPDFBox* __fastcall GetMediaBox(void);
	TPDFBox* __fastcall GetTrimBox(void);
	void __fastcall SetMediaBox(const TPDFBox* Value);
	void __fastcall SetTrimBox(const TPDFBox* Value);
	
public:
	__fastcall TPDFDocument(Classes::TComponent* AOwner, Classes::TStream* Stream);
	__fastcall virtual ~TPDFDocument(void);
	void __fastcall BeginDoc(void);
	void __fastcall EndDoc(void);
	void __fastcall AddFont(TPDFFont* NewFont);
	void __fastcall NewPage(void);
	void __fastcall EndPage(void);
	void __fastcall StringOut(int x, int y, const AnsiString Str, Graphics::TColor Color);
	void __fastcall TextOut(int x, int y, const Classes::TStrings* Text);
	void __fastcall Line(double x1, double y1, double x2, double y2, Graphics::TColor Color);
	void __fastcall FillRect(double x1, double y1, double x2, double y2, Graphics::TColor Color);
	void __fastcall SetTextFont(TPDFFont* Value);
	Graphics::TColor __fastcall ChangeFillColor(Graphics::TColor Color);
	Graphics::TColor __fastcall ChangeLineColor(Graphics::TColor Color);
	
__published:
	__property int ObjNumber = {read=FObjNumber, nodefault};
	__property TPDFFont* Font = {read=FFont, write=SetFont};
	__property double LineWidth = {read=FLineWidth, write=FLineWidth};
	__property double LineSpacing = {read=FLineSpacing, write=FLineSpacing};
	__property Graphics::TColor LineColor = {read=FLineColor, nodefault};
	__property Graphics::TColor FillColor = {read=FFillColor, nodefault};
	__property TPDFBox* MediaBox = {read=GetMediaBox, write=SetMediaBox};
	__property TPDFBox* TrimBox = {read=GetTrimBox, write=SetTrimBox};
public:
	#pragma option push -w-inl
	/* TComponent.Create */ inline __fastcall virtual TPDFDocument(Classes::TComponent* AOwner) : Classes::TComponent(AOwner) { }
	#pragma option pop
	
};


class DELPHICLASS TQPDFWriter;
class PASCALIMPLEMENTATION TQPDFWriter : public Qexport3::TQExportWriter 
{
	typedef Qexport3::TQExportWriter inherited;
	
private:
	TPDFDocument* FPDFDocument;
	
public:
	__fastcall virtual TQPDFWriter(Qexport3::TQExport3* AOwner, Classes::TStream* AStream);
	__fastcall virtual ~TQPDFWriter(void);
	
__published:
	__property TPDFDocument* PDFDocument = {read=FPDFDocument};
};


class DELPHICLASS TQExportPDFPageOptions;
class PASCALIMPLEMENTATION TQExportPDFPageOptions : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Qexport3::TQExportUnits FUnits;
	Qexport3::TQExportPageFormat FFormat;
	int FWidth;
	int FHeight;
	Qexport3::TQExportPageOrientation FOrientation;
	int FMarginLeft;
	int FMarginRight;
	int FMarginTop;
	int FMarginBottom;
	TPDFBox* FMediaBox;
	TPDFBox* FTrimBox;
	void __fastcall SetFormat(const Qexport3::TQExportPageFormat Value);
	bool __fastcall IsWidth(void);
	double __fastcall GetWidth(void);
	void __fastcall SetWidth(const double Value);
	bool __fastcall IsHeight(void);
	double __fastcall GetHeight(void);
	void __fastcall SetHeight(const double Value);
	void __fastcall SetOrientation(const Qexport3::TQExportPageOrientation Value);
	double __fastcall GetMarginLeft(void);
	void __fastcall SetMarginLeft(const double Value);
	double __fastcall GetMarginRight(void);
	void __fastcall SetMarginRight(const double Value);
	double __fastcall GetMarginTop(void);
	void __fastcall SetMarginTop(const double Value);
	double __fastcall GetMarginBottom(void);
	void __fastcall SetMarginBottom(const double Value);
	TPDFBox* __fastcall GetMediaBox(void);
	TPDFBox* __fastcall GetTrimBox(void);
	
protected:
	__property TPDFBox* MediaBox = {read=GetMediaBox};
	__property TPDFBox* TrimBox = {read=GetTrimBox};
	
public:
	__fastcall TQExportPDFPageOptions(void);
	__fastcall virtual ~TQExportPDFPageOptions(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Qexport3::TQExportUnits Units = {read=FUnits, write=FUnits, default=0};
	__property double Width = {read=GetWidth, write=SetWidth, stored=IsWidth};
	__property double Height = {read=GetHeight, write=SetHeight, stored=IsHeight};
	__property Qexport3::TQExportPageFormat Format = {read=FFormat, write=SetFormat, default=3};
	__property Qexport3::TQExportPageOrientation Orientation = {read=FOrientation, write=SetOrientation, default=0};
	__property double MarginLeft = {read=GetMarginLeft, write=SetMarginLeft};
	__property double MarginRight = {read=GetMarginRight, write=SetMarginRight};
	__property double MarginTop = {read=GetMarginTop, write=SetMarginTop};
	__property double MarginBottom = {read=GetMarginBottom, write=SetMarginBottom};
};


class DELPHICLASS TPDFOptions;
class PASCALIMPLEMENTATION TPDFOptions : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TPDFFont* FHeaderFont;
	TPDFFont* FCaptionFont;
	TPDFFont* FDataFont;
	TPDFFont* FFooterFont;
	TQExportPDFPageOptions* FPageOptions;
	double FRowSpacing;
	double FColSpacing;
	int FGridLineWidth;
	Graphics::TColor FGridLineColor;
	bool __fastcall IsRowSpacing(void);
	bool __fastcall IsColSpacing(void);
	void __fastcall SetHeaderFont(const TPDFFont* Value);
	void __fastcall SetCaptionFont(const TPDFFont* Value);
	void __fastcall SetDataFont(const TPDFFont* Value);
	void __fastcall SetFooterFont(const TPDFFont* Value);
	void __fastcall SetPageOptions(const TQExportPDFPageOptions* Value);
	
public:
	__fastcall TPDFOptions(void);
	__fastcall virtual ~TPDFOptions(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property TQExportPDFPageOptions* PageOptions = {read=FPageOptions, write=SetPageOptions};
	__property TPDFFont* HeaderFont = {read=FHeaderFont, write=SetHeaderFont};
	__property TPDFFont* CaptionFont = {read=FCaptionFont, write=SetCaptionFont};
	__property TPDFFont* DataFont = {read=FDataFont, write=SetDataFont};
	__property TPDFFont* FooterFont = {read=FFooterFont, write=SetFooterFont};
	__property double RowSpacing = {read=FRowSpacing, write=FRowSpacing, stored=IsRowSpacing};
	__property double ColSpacing = {read=FColSpacing, write=FColSpacing, stored=IsColSpacing};
	__property int GridLineWidth = {read=FGridLineWidth, write=FGridLineWidth, default=1};
	__property Graphics::TColor GridLineColor = {read=FGridLineColor, write=FGridLineColor, default=0};
};


class DELPHICLASS TQExport3PDF;
class PASCALIMPLEMENTATION TQExport3PDF : public Qexport3::TQExport3FormatText 
{
	typedef Qexport3::TQExport3FormatText inherited;
	
private:
	TPDFOptions* FOptions;
	int CurY;
	int TableBeginY;
	Classes::TList* ColXs;
	void __fastcall SetOptions(const TPDFOptions* Value);
	void __fastcall PlotVertGridLines(int Top, int Bottom);
	
protected:
	virtual void __fastcall BeginExport(void);
	virtual void __fastcall WriteCaptionRow(void);
	virtual void __fastcall WriteDataRow(void);
	void __fastcall WriteHeader(void);
	void __fastcall WriteFooter(void);
	virtual void __fastcall EndExport(void);
	HIDESBASE TQPDFWriter* __fastcall GetWriter(void);
	virtual TMetaClass* __fastcall GetWriterClass(void);
	virtual Qexport3::TSpecialCharacters __fastcall GetSpecialCharacters();
	
public:
	__fastcall virtual TQExport3PDF(Classes::TComponent* AOwner);
	__fastcall virtual ~TQExport3PDF(void);
	virtual AnsiString __fastcall NormalString(const AnsiString S);
	
__published:
	__property TPDFOptions* Options = {read=FOptions, write=SetOptions};
	__property ColumnsWidth ;
	__property ColumnsAlign ;
	__property OnGetCellParams ;
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Qexport3pdf */
using namespace Qexport3pdf;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QExport3PDF
